/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: FileSystem.java,v af5e94efb8ca 2010/06/26 18:14:20 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.mobile.io;

import javax.annotation.Nonnull;
import javax.annotation.Nonnegative;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id:$
 *
 **********************************************************************************************************************/
public interface FileSystem
  { 
    @Nonnull
    public OutputStream openFileOutput (@Nonnull String path)
      throws IOException;

    @Nonnull
    public InputStream openFileInput (@Nonnull String path)
      throws IOException;

    @Nonnull
    public File getFile (@Nonnull String path)
      throws IOException;

    @Nonnegative
    public long getFreeSpace();
  }
